%define name		jedit
%define Name		jEdit
%define	major		4
%define minor		2
%define pre		pre5
%define rel		1jpp
%define version		%{major}.%{minor}
%define fversion	%{major}%{minor}%{pre}
%define rversion	%{major}.%{minor}.%{pre}
%define relpre		0.%{pre}.%{rel}
%if %{?pre:1}%{!?pre:0}
%define release		%{relpre}
%else
%define release		%{rel}
%endif
%define Summary		Open Source programmer's text editor
%define section		free

Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		0
Summary:	%{Summary}
License:	GPL
Group:		Text Editors
Source0:	http://osdn.dl.sourceforge.net/jedit/jedit42pre4source.tar.gz
Source1:	%{name}-16.png
Source2:	%{name}-32.png
Source3:	%{name}-48.png
URL:		http://www.%{name}.org/
BuildRequires:	ant
BuildRequires:	aelfred
#BuildRequires:	bsh
BuildRequires:	gnu.regexp
BuildRequires:	%{_bindir}/xsltproc
BuildRequires:	docbook-style-xsl
Requires:	aelfred
#Requires:	bsh
Requires:	gnu.regexp
Requires:	jpackage-utils >= 0:1.5
#Requires:	%{name}-manual = %{version}-%{release}
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
Vendor:		JPackage Project
Distribution:	JPackage

%description
jEdit is a programmer's text editor written in Java, being developed by Slava
Pestov and others.

Some of jEdit's features include:

    * Built-in macro language (BeanShell).
    * Extensible plugin architecture, with more than 60 plugins available.
    * Plugins can be downloaded and installed from within jEdit using the
      "plugin manager" feature.
    * Syntax highlighting for 70 languages.
    * Supports a large number of character encodings including UTF8 and
      Unicode.
    * Auto-indenting of source code.
    * Folding (indent and 'marker' based).
    * Word wrap.
    * Unlimited undo/redo.
    * Highly configurable and customizable.
    * Every other feature, both basic and advanced, you would expect to
      find in a text editor.

You can find a complete listing of features here.

jEdit is released under the terms of the GNU General Public License.

#%package manual
#Summary:        Manual for %{name}
#Group:          Development/Java
#
#%description manual
#Documentation for %{name}.

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
Javadoc for %{name}.

%package mdkmenu
Summary:	Mandrake menu entry for %{name}
Group:		Development
Requires:	%{name} = %{version}-%{release}

%description mdkmenu
This is a Mandrake menu system entry for %{name}.

%package rhmenu
Summary:	Red Hat menu entry for %{name}
Group:		Development
Requires:	%{name} = %{version}-%{release}

%description rhmenu
This is a Red Hat menu system entry for %{name}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -n jEdit
# remove all included external sources
rm -rf com/
#rm -rf bsh/
rm -rf gnu/
install -m 644 %{SOURCE1} %{name}-16.png
install -m 644 %{SOURCE2} %{name}-32.png
install -m 644 %{SOURCE3} %{name}-48.png

%build
JAVA_HOME=%java_home

#export CLASSPATH=$(build-classpath aelfred bsh gnu.regexp)
export CLASSPATH=$(build-classpath aelfred gnu.regexp)

ant

DOCBOOK_XSL=`rpm -ql docbook-style-xsl | grep /html/chunk.xsl \
| sed 's#/html/chunk.xsl##'`

if [ -z $DOCBOOK_XSL ]; then
  echo "Unable to find docbook xsl directory"
  exit 1
fi

ant -Ddocbook.xsl=$DOCBOOK_XSL docs-html-xsltproc dist

# Build LatestVersion.jar
(cd jars/LatestVersion && ant)

# Build QuickNotepad.jar
(cd jars/QuickNotepad && ant)

# Create installer filelists
sh installer/mk_filelist.sh

ant javadoc

%install
JAVA_HOME=%java_home

java -cp . installer.Install auto $RPM_BUILD_ROOT%{_datadir}/%{name} \
unix-man=$RPM_BUILD_ROOT%{_mandir}/man1

# manual
# FIXME: Broken in JPackage 1.5
rm -rf $RPM_BUILD_ROOT%{_datadir}/%{name}/%{version}/doc/users-guide
#find doc/users-guide -type f ! -name \*.html | xargs rm
#(cd $RPM_BUILD_ROOT%{_datadir}/%{name}/%{version}/doc && \
#ln -sf %{_docdir}/%{name}-manual-%{version}/users-guide users-guide)

# script
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
cat > $RPM_BUILD_ROOT%{_bindir}/%{name} << EOF
#!/bin/sh
#
# jedit script
# JPackage Project (http://jpackage.sourceforge.net)

# Source functions library
. %{_datadir}/java-utils/java-functions

# Source system prefs
if [ -f %{_sysconfdir}/%{name}.conf ] ; then
  . %{_sysconfdir}/%{name}.conf
fi

# Source user prefs
if [ -f \$HOME/.%{name}rc ] ; then
  . \$HOME/.%{name}rc
fi

# Configuration
MAIN_CLASS="org.gjt.sp.jedit.jEdit"
BASE_FLAGS="-Djedit.home=%{_datadir}/%{name} -mx32m"
#BASE_JARS="aelfred bsh gnu.regexp %{name}"
BASE_JARS="aelfred gnu.regexp %{name}"

# Set parameters
set_jvm
set_classpath \$BASE_JARS
set_flags \$BASE_FLAGS

# Let's start
run "\$@"
EOF

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

# mdk icons
install -D -m 644 %{name}-48.png $RPM_BUILD_ROOT%{_liconsdir}/%{name}.png
install -D -m 644 %{name}-32.png $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png
install -D -m 644 %{name}-16.png $RPM_BUILD_ROOT%{_miconsdir}/%{name}.png

# mdk menu
install -d -m 755 $RPM_BUILD_ROOT%{_menudir}
cat >$RPM_BUILD_ROOT%{_menudir}/%{name} <<EOF
?package(%{name}):\
 command="%{_bindir}/%{name}"\
 needs="X11"\
 section="Applications/Editors"\
 mimetypes="text/html;text/plain"\
 title="%{Name}"\
 longtitle="%{Summary}"\
 icon="%{name}.png"
EOF

# rh icons
install -D -m 644 %{name}-48.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
install -D -m 644 %{name}-32.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -D -m 644 %{name}-16.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png

# rh menu 
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Development
cat >$RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Development/%{name}.desktop <<EOF
[Desktop Entry]
Name=%{Name}
Comment=%{Summary}
Exec=%{_bindir}/%{name}
Terminal=0
Type=Application
Icon=%{name}.png
EOF

# jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 %{name}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)
(cd $RPM_BUILD_ROOT%{_datadir}/%{name} && \
ln -sf %{_javadir}/%{name}.jar %{name}.jar)

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%post mdkmenu
%{update_menus}

%postun mdkmenu
%{clean_menus}

%files
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/%{name}
%{_javadir}/*
%{_datadir}/%{name}
%{_mandir}/man1/%{name}.1*

#%files manual
#%defattr(-,root,root)
#%doc doc/users-guide

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}

%files mdkmenu
%defattr(-,root,root)
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%files rhmenu
%defattr(-,root,root)
%{_sysconfdir}/X11/applnk/*/*
%{_datadir}/icons/*/*/apps/*

%changelog
* Wed Sep 10 2003 David Walluck <david@anti-microsoft.org> 0:4.2-0.pre5.1jpp
- 4.2pre5

* Tue Aug 28 2003 David Walluck <david@anti-microsoft.org> 0:4.2-0.pre4.1jpp
- merge changes provided by Jordi Murgo <jordi@lleida.com>
- 4.2pre4
- use jedit bsh for now

* Sun May 04 2003 David Walluck <david@anti-microsoft.org> 0:4.2-0.pre1.2jpp
- fix %%release macro which seems to not be working as it once was
- fix javadoc symlinks

* Fri May 02 2003 David Walluck <david@anti-microsoft.org> 0:4.2-0.pre1.1jpp
- 4.2pre1
- update URL tag

* Mon Apr 21 2003 David Walluck <david@anti-microsoft.org> 0:4.1-4jpp
- include non-versioned javadoc symlinks
- user manual magically works again

* Fri Apr 11 2003 David Walluck <david@anti-microsoft.org> 0:4.1-3jpp
- more JPackage 1.5 updates

* Sun Apr 6 2003 David Walluck <david@anti-microsoft.org> 4.1-2jpp
- update for JPackage 1.5
- user manual broken

* Fri Feb 28 2003 David Walluck <david@anti-microsoft.org> 4.1-1jpp
- 4.1

* Sun Feb 23 2003 David Walluck <david@anti-microsoft.org> 4.1-0.pre11.1jpp
- 4.1pre11
- release tag handles both final and pre releases
- update Url

* Sun Feb 16 2003 David Walluck <david@anti-microsoft.org> 4.1-0.pre10.2jpp
- Requires: jpackage-utils (suggested by Pete Chown
  <Pete.Chown at skygate.co.uk>)
- manpage back (installer has changed)
- install to %%{_datadir}/%%{name} instead of %%{_datadir}/%%{name}/%%{version}
- add real jar in %%{_javadir} and symlink to %%{_datadir}/%%{name}
  (useful for building plugins)

* Fri Feb 14 2003 David Walluck <david@anti-microsoft.org> 4.1-0.pre10.1jpp
- 4.1pre10
- back to auto-install, but no manpage

* Fri Jan 31 2003 David Walluck <david@anti-microsoft.org> 4.1-0.pre9.2jpp
- add user's guide back into the main package

* Fri Jan 31 2003 David Walluck <david@anti-microsoft.org> 4.1-0.pre9.1jpp
- release

* Sun Jan 26 2003 David Walluck <david@anti-microsoft.org> 4.1-0.pre8.4jpp
- add javadocs
- split off users-guide into optional manual package

* Sun Jan 26 2003 David Walluck <david@anti-microsoft.org> 4.1-0.pre8.3jpp
- set JAVA_HOME/bin in PATH (suggested by Ville Skytt
  <ville.skytta at iki.fi>)
- fixed menu entry summaries (Ville Skytt <ville.skytta at iki.fi>)

* Sat Jan 25 2003 Ville Skytt <ville.skytta at iki.fi> - 4.1-0.pre8.2jpp
- (Build)Require jpackage-utils, and use java-functions from it.
- Fixed menu entry summaries.

* Thu Jan 23 2003 David Walluck <david@anti-microsoft.org> 4.1-0.pre8.1jpp
- remove bsh from jedit.jar
- fix release tag

* Mon Jan 20 2003 David Walluck <david@anti-microsoft.org> 4.1-0.8.0jpp
- 4.1pre8
- look for chunk.xsl
- remove aelfred and gnu.regexp from jedit.jar (bsh forthcoming) 

* Mon Oct 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 4.0.3-1jpp
- first jpackage release (David Walluck <david@anti-microsoft.org>)
